Index: irc_commands.c
===================================================================
--- irc_commands.c	(revision 47fae0ffdda6ea4509ba00b56d15fb25ffe19eea)
+++ irc_commands.c	(revision ec2ebcc07f4df02aee43712dae1245eb34c48575)
@@ -2,5 +2,5 @@
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2010 Wilmer van der Gaast and others                *
+  * Copyright 2002-2006 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -53,10 +53,10 @@
 	else if( global.conf->auth_pass )
 	{
-		irc_send_num( irc, 464, ":Incorrect password" );
+		irc_reply( irc, 464, ":Incorrect password" );
 	}
 	else
 	{
 		/* Remember the password and try to identify after USER/NICK. */
-		/*irc_setpass( irc, cmd[1] ); */
+		irc_setpass( irc, cmd[1] );
 		irc_check_login( irc );
 	}
@@ -65,6 +65,6 @@
 static void irc_cmd_user( irc_t *irc, char **cmd )
 {
-	irc->user->user = g_strdup( cmd[1] );
-	irc->user->fullname = g_strdup( cmd[4] );
+	irc->user = g_strdup( cmd[1] );
+	irc->realname = g_strdup( cmd[4] );
 	
 	irc_check_login( irc );
@@ -73,27 +73,21 @@
 static void irc_cmd_nick( irc_t *irc, char **cmd )
 {
-	if( irc_user_by_name( irc, cmd[1] ) )
-	{
-		irc_send_num( irc, 433, ":This nick is already in use" );
+	if( irc->nick )
+	{
+		irc_reply( irc, 438, ":The hand of the deity is upon thee, thy nick may not change" );
+	}
+	/* This is not clean, but for now it'll have to be like this... */
+	else if( ( nick_cmp( cmd[1], irc->mynick ) == 0 ) || ( nick_cmp( cmd[1], NS_NICK ) == 0 ) )
+	{
+		irc_reply( irc, 433, ":This nick is already in use" );
 	}
 	else if( !nick_ok( cmd[1] ) )
 	{
 		/* [SH] Invalid characters. */
-		irc_send_num( irc, 432, ":This nick contains invalid characters" );
-	}
-	else if( irc->user->nick )
-	{
-		if( irc->status & USTATUS_IDENTIFIED )
-		{
-			irc_setpass( irc, NULL );
-			irc->status &= ~USTATUS_IDENTIFIED;
-			irc_umode_set( irc, "-R", 1 );
-		}
-		
-		irc_user_set_nick( irc->user, cmd[1] );
-	}
-	else
-	{
-		irc->user->nick = g_strdup( cmd[1] );
+		irc_reply( irc, 432, ":This nick contains invalid characters" );
+	}
+	else
+	{
+		irc->nick = g_strdup( cmd[1] );
 		
 		irc_check_login( irc );
@@ -111,200 +105,130 @@
 static void irc_cmd_ping( irc_t *irc, char **cmd )
 {
-	irc_write( irc, ":%s PONG %s :%s", irc->root->host,
-	           irc->root->host, cmd[1]?cmd[1]:irc->root->host );
-}
-
-static void irc_cmd_pong( irc_t *irc, char **cmd )
-{
-	/* We could check the value we get back from the user, but in
-	   fact we don't care, we're just happy s/he's still alive. */
-	irc->last_pong = gettime();
-	irc->pinging = 0;
-}
-
-static void irc_cmd_join( irc_t *irc, char **cmd )
-{
-	irc_channel_t *ic;
-	
-	if( ( ic = irc_channel_by_name( irc, cmd[1] ) ) == NULL )
-		ic = irc_channel_new( irc, cmd[1] );
-	
-	if( ic == NULL )
-	{
-		irc_send_num( irc, 479, "%s :Invalid channel name", cmd[1] );
-		return;
-	}
-	
-	if( ic->flags & IRC_CHANNEL_JOINED )
-		return; /* Dude, you're already there...
-		           RFC doesn't have any reply for that though? */
-	
-	irc_channel_add_user( ic, irc->user );
-}
-
-static void irc_cmd_names( irc_t *irc, char **cmd )
-{
-	irc_channel_t *ic;
-	
-	if( cmd[1] && ( ic = irc_channel_by_name( irc, cmd[1] ) ) )
-		irc_send_names( ic );
-	/* With no args, we should show /names of all chans. Make the code
-	   below work well if necessary.
-	else
-	{
-		GSList *l;
-		
-		for( l = irc->channels; l; l = l->next )
-			irc_send_names( l->data );
-	}
-	*/
-}
-
-static void irc_cmd_part( irc_t *irc, char **cmd )
-{
-	irc_channel_t *ic;
-	
-	if( ( ic = irc_channel_by_name( irc, cmd[1] ) ) == NULL )
-	{
-		irc_send_num( irc, 403, "%s :No such channel", cmd[1] );
-	}
-	else if( irc_channel_del_user( ic, irc->user ) )
-	{
-		if( ic->f->part )
-			ic->f->part( ic, NULL );
-	}
-	else
-	{
-		irc_send_num( irc, 442, "%s :You're not on that channel", cmd[1] );
-	}
-}
-
-static void irc_cmd_whois( irc_t *irc, char **cmd )
-{
-	char *nick = cmd[1];
-	irc_user_t *iu = irc_user_by_name( irc, nick );
-	
-	if( iu )
-		irc_send_whois( iu );
-	else
-		irc_send_num( irc, 401, "%s :Nick does not exist", nick );
-}
-
-static void irc_cmd_whowas( irc_t *irc, char **cmd )
-{
-	/* For some reason irssi tries a whowas when whois fails. We can
-	   ignore this, but then the user never gets a "user not found"
-	   message from irssi which is a bit annoying. So just respond
-	   with not-found and irssi users will get better error messages */
-	
-	irc_send_num( irc, 406, "%s :Nick does not exist", cmd[1] );
-	irc_send_num( irc, 369, "%s :End of WHOWAS", cmd[1] );
-}
-
-static void irc_cmd_motd( irc_t *irc, char **cmd )
-{
-	irc_send_motd( irc );
+	irc_write( irc, ":%s PONG %s :%s", irc->myhost, irc->myhost, cmd[1]?cmd[1]:irc->myhost );
+}
+
+static void irc_cmd_oper( irc_t *irc, char **cmd )
+{
+	if( global.conf->oper_pass &&
+	    ( strncmp( global.conf->oper_pass, "md5:", 4 ) == 0 ?
+	        md5_verify_password( cmd[2], global.conf->oper_pass + 4 ) == 0 :
+	        strcmp( cmd[2], global.conf->oper_pass ) == 0 ) )
+	{
+		irc_umode_set( irc, "+o", 1 );
+		irc_reply( irc, 381, ":Password accepted" );
+	}
+	else
+	{
+		irc_reply( irc, 432, ":Incorrect password" );
+	}
 }
 
 static void irc_cmd_mode( irc_t *irc, char **cmd )
 {
-	if( irc_channel_name_ok( cmd[1] ) )
-	{
-		irc_channel_t *ic;
-		
-		if( ( ic = irc_channel_by_name( irc, cmd[1] ) ) == NULL )
-			irc_send_num( irc, 403, "%s :No such channel", cmd[1] );
-		else if( cmd[2] )
+	if( strchr( CTYPES, *cmd[1] ) )
+	{
+		if( cmd[2] )
 		{
 			if( *cmd[2] == '+' || *cmd[2] == '-' )
-				irc_send_num( irc, 477, "%s :Can't change channel modes", cmd[1] );
+				irc_reply( irc, 477, "%s :Can't change channel modes", cmd[1] );
 			else if( *cmd[2] == 'b' )
-				irc_send_num( irc, 368, "%s :No bans possible", cmd[1] );
+				irc_reply( irc, 368, "%s :No bans possible", cmd[1] );
 		}
 		else
-			irc_send_num( irc, 324, "%s +%s", cmd[1], ic->mode );
-	}
-	else
-	{
-		if( nick_cmp( cmd[1], irc->user->nick ) == 0 )
+			irc_reply( irc, 324, "%s +%s", cmd[1], CMODE );
+	}
+	else
+	{
+		if( nick_cmp( cmd[1], irc->nick ) == 0 )
 		{
 			if( cmd[2] )
 				irc_umode_set( irc, cmd[2], 0 );
 			else
-				irc_send_num( irc, 221, "+%s", irc->umode );
+				irc_reply( irc, 221, "+%s", irc->umode );
 		}
 		else
-			irc_send_num( irc, 502, ":Don't touch their modes" );
-	}
-}
-
-static void irc_cmd_who( irc_t *irc, char **cmd )
-{
-	char *channel = cmd[1];
-	irc_channel_t *ic;
-	
-	if( !channel || *channel == '0' || *channel == '*' || !*channel )
-		irc_send_who( irc, irc->users, "**" );
-	else if( ( ic = irc_channel_by_name( irc, channel ) ) )
-		irc_send_who( irc, ic->users, channel );
-	else
-		irc_send_num( irc, 403, "%s :No such channel", channel );
+			irc_reply( irc, 502, ":Don't touch their modes" );
+	}
+}
+
+static void irc_cmd_names( irc_t *irc, char **cmd )
+{
+	irc_names( irc, cmd[1]?cmd[1]:irc->channel );
+}
+
+static void irc_cmd_part( irc_t *irc, char **cmd )
+{
+	struct groupchat *c;
+	
+	if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+	{
+		user_t *u = user_find( irc, irc->nick );
+		
+		/* Not allowed to leave control channel */
+		irc_part( irc, u, irc->channel );
+		irc_join( irc, u, irc->channel );
+	}
+	else if( ( c = irc_chat_by_channel( irc, cmd[1] ) ) )
+	{
+		user_t *u = user_find( irc, irc->nick );
+		
+		irc_part( irc, u, c->channel );
+		
+		if( c->ic )
+		{
+			c->joined = 0;
+			c->ic->acc->prpl->chat_leave( c );
+		}
+	}
+	else
+	{
+		irc_reply( irc, 403, "%s :No such channel", cmd[1] );
+	}
+}
+
+static void irc_cmd_join( irc_t *irc, char **cmd )
+{
+	if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+		; /* Dude, you're already there...
+		     RFC doesn't have any reply for that though? */
+	else if( cmd[1] )
+	{
+		struct chat *c;
+		
+		if( strchr( CTYPES, cmd[1][0] ) == NULL || cmd[1][1] == 0 )
+			irc_reply( irc, 479, "%s :Invalid channel name", cmd[1] );
+		else if( ( c = chat_bychannel( irc, cmd[1] ) ) && c->acc && c->acc->ic )
+			chat_join( irc, c, cmd[2] );
+		else
+			irc_reply( irc, 403, "%s :No such channel", cmd[1] );
+	}
+}
+
+static void irc_cmd_invite( irc_t *irc, char **cmd )
+{
+	char *nick = cmd[1], *channel = cmd[2];
+	struct groupchat *c = irc_chat_by_channel( irc, channel );
+	user_t *u = user_find( irc, nick );
+	
+	if( u && c && ( u->ic == c->ic ) )
+		if( c->ic && c->ic->acc->prpl->chat_invite )
+		{
+			c->ic->acc->prpl->chat_invite( c, u->handle, NULL );
+			irc_reply( irc, 341, "%s %s", nick, channel );
+			return;
+		}
+	
+	irc_reply( irc, 482, "%s :Invite impossible; User/Channel non-existent or incompatible", channel );
 }
 
 static void irc_cmd_privmsg( irc_t *irc, char **cmd )
 {
-	irc_channel_t *ic;
-	irc_user_t *iu;
-	
-	if( !cmd[2] ) 
-	{
-		irc_send_num( irc, 412, ":No text to send" );
-		return;
-	}
-	
-	/* Don't treat CTCP actions as real CTCPs, just convert them right now. */
-	if( g_strncasecmp( cmd[2], "\001ACTION", 7 ) == 0 )
-	{
-		cmd[2] += 4;
-		strcpy( cmd[2], "/me" );
-		if( cmd[2][strlen(cmd[2])-1] == '\001' )
-			cmd[2][strlen(cmd[2])-1] = '\0';
-	}
-	
-	if( irc_channel_name_ok( cmd[1] ) &&
-	    ( ic = irc_channel_by_name( irc, cmd[1] ) ) )
-	{
-		if( ic->f->privmsg )
-			ic->f->privmsg( ic, cmd[2] );
-	}
-	else if( ( iu = irc_user_by_name( irc, cmd[1] ) ) )
-	{
-		if( cmd[2][0] == '\001' )
-		{
-			char **ctcp;
-			
-			if( iu->f->ctcp == NULL )
-				return;
-			if( cmd[2][strlen(cmd[2])-1] == '\001' )
-				cmd[2][strlen(cmd[2])-1] = '\0';
-			
-			ctcp = split_command_parts( cmd[2] + 1 );
-			iu->f->ctcp( iu, ctcp );
-		}
-		else if( iu->f->privmsg )
-		{
-			iu->flags |= IRC_USER_PRIVATE;
-			iu->f->privmsg( iu, cmd[2] );
-		}
-	}
-	else
-	{
-		irc_send_num( irc, 401, "%s :No such nick/channel", cmd[1] );
-	}
-
-
-#if 0
-	else if( irc->nick && g_strcasecmp( cmd[1], irc->nick ) == 0 ) 
-	{
+	if ( !cmd[2] ) 
+	{
+		irc_reply( irc, 412, ":No text to send" );
+	}
+	else if ( irc->nick && g_strcasecmp( cmd[1], irc->nick ) == 0 ) 
+	{
+		irc_write( irc, ":%s!%s@%s %s %s :%s", irc->nick, irc->user, irc->host, cmd[0], cmd[1], cmd[2] ); 
 	}
 	else 
@@ -347,56 +271,41 @@
 		irc_send( irc, cmd[1], cmd[2], ( g_strcasecmp( cmd[0], "NOTICE" ) == 0 ) ? OPT_AWAY : 0 );
 	}
-#endif
-}
-
-static void irc_cmd_nickserv( irc_t *irc, char **cmd )
-{
-	/* [SH] This aliases the NickServ command to PRIVMSG root */
-	/* [TV] This aliases the NS command to PRIVMSG root as well */
-	root_command( irc, cmd + 1 );
-}
-
-
-
-static void irc_cmd_oper( irc_t *irc, char **cmd )
-{
-	if( global.conf->oper_pass &&
-	    ( strncmp( global.conf->oper_pass, "md5:", 4 ) == 0 ?
-	        md5_verify_password( cmd[2], global.conf->oper_pass + 4 ) == 0 :
-	        strcmp( cmd[2], global.conf->oper_pass ) == 0 ) )
-	{
-		irc_umode_set( irc, "+o", 1 );
-		irc_send_num( irc, 381, ":Password accepted" );
-	}
-	else
-	{
-		irc_send_num( irc, 432, ":Incorrect password" );
-	}
-}
-
-static void irc_cmd_invite( irc_t *irc, char **cmd )
-{
-	irc_channel_t *ic;
-	irc_user_t *iu;
-	
-	if( ( iu = irc_user_by_name( irc, cmd[1] ) ) == NULL )
-	{
-		irc_send_num( irc, 401, "%s :No such nick", cmd[1] );
-		return;
-	}
-	else if( ( ic = irc_channel_by_name( irc, cmd[2] ) ) == NULL )
-	{
-		irc_send_num( irc, 403, "%s :No such channel", cmd[2] );
-		return;
-	}
-	
-	if( ic->f->invite )
-		ic->f->invite( ic, iu );
-	else
-		irc_send_num( irc, 482, "%s :Can't invite people here", cmd[2] );
+}
+
+static void irc_cmd_who( irc_t *irc, char **cmd )
+{
+	char *channel = cmd[1];
+	user_t *u = irc->users;
+	struct groupchat *c;
+	GList *l;
+	
+	if( !channel || *channel == '0' || *channel == '*' || !*channel )
+		while( u )
+		{
+			irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", u->online ? irc->channel : "*", u->user, u->host, irc->myhost, u->nick, u->online ? ( u->away ? 'G' : 'H' ) : 'G', u->realname );
+			u = u->next;
+		}
+	else if( g_strcasecmp( channel, irc->channel ) == 0 )
+		while( u )
+		{
+			if( u->online )
+				irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->away ? 'G' : 'H', u->realname );
+			u = u->next;
+		}
+	else if( ( c = irc_chat_by_channel( irc, channel ) ) )
+		for( l = c->in_room; l; l = l->next )
+		{
+			if( ( u = user_findhandle( c->ic, l->data ) ) )
+				irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->away ? 'G' : 'H', u->realname );
+		}
+	else if( ( u = user_find( irc, channel ) ) )
+		irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->online ? ( u->away ? 'G' : 'H' ) : 'G', u->realname );
+	
+	irc_reply( irc, 315, "%s :End of /WHO list", channel?channel:"**" );
 }
 
 static void irc_cmd_userhost( irc_t *irc, char **cmd )
 {
+	user_t *u;
 	int i;
 	
@@ -408,16 +317,16 @@
 	
 	for( i = 1; cmd[i]; i ++ )
-	{
-		irc_user_t *iu = irc_user_by_name( irc, cmd[i] );
-		
-		if( iu )
-			irc_send_num( irc, 302, ":%s=%c%s@%s", iu->nick,
-			              irc_user_get_away( iu ) ? '-' : '+',
-			              iu->user, iu->host );
-	}
+		if( ( u = user_find( irc, cmd[i] ) ) )
+		{
+			if( u->online && u->away )
+				irc_reply( irc, 302, ":%s=-%s@%s", u->nick, u->user, u->host );
+			else
+				irc_reply( irc, 302, ":%s=+%s@%s", u->nick, u->user, u->host );
+		}
 }
 
 static void irc_cmd_ison( irc_t *irc, char **cmd )
 {
+	user_t *u;
 	char buff[IRC_MAX_LINE];
 	int lenleft, i;
@@ -435,18 +344,15 @@
 		while( *this )
 		{
-			irc_user_t *iu;
-			
 			if( ( next = strchr( this, ' ' ) ) )
 				*next = 0;
 			
-			if( ( iu = irc_user_by_name( irc, this ) ) &&
-			    iu->bu && iu->bu->flags & BEE_USER_ONLINE )
-			{
-				lenleft -= strlen( iu->nick ) + 1;
+			if( ( u = user_find( irc, this ) ) && u->online )
+			{
+				lenleft -= strlen( u->nick ) + 1;
 				
 				if( lenleft < 0 )
 					break;
 				
-				strcat( buff, iu->nick );
+				strcat( buff, u->nick );
 				strcat( buff, " " );
 			}
@@ -471,5 +377,5 @@
 		buff[strlen(buff)-1] = '\0';
 	
-	irc_send_num( irc, 303, ":%s", buff );
+	irc_reply( irc, 303, ":%s", buff );
 }
 
@@ -484,5 +390,5 @@
 	{
 		char *nick;
-		irc_user_t *iu;
+		user_t *u;
 		
 		if( !cmd[i][0] || !cmd[i][1] )
@@ -492,5 +398,5 @@
 		nick_lc( nick );
 		
-		iu = irc_user_by_name( irc, nick );
+		u = user_find( irc, nick );
 		
 		if( cmd[i][0] == '+' )
@@ -499,10 +405,8 @@
 				g_hash_table_insert( irc->watches, nick, nick );
 			
-			if( iu && iu->bu && iu->bu->flags & BEE_USER_ONLINE )
-				irc_send_num( irc, 604, "%s %s %s %d :%s", iu->nick, iu->user,
-				              iu->host, (int) time( NULL ), "is online" );
+			if( u && u->online )
+				irc_reply( irc, 604, "%s %s %s %d :%s", u->nick, u->user, u->host, (int) time( NULL ), "is online" );
 			else
-				irc_send_num( irc, 605, "%s %s %s %d :%s", nick, "*", "*",
-				              (int) time( NULL ), "is offline" );
+				irc_reply( irc, 605, "%s %s %s %d :%s", nick, "*", "*", (int) time( NULL ), "is offline" );
 		}
 		else if( cmd[i][0] == '-' )
@@ -515,11 +419,10 @@
 				g_free( okey );
 				
-				irc_send_num( irc, 602, "%s %s %s %d :%s", nick, "*", "*", 0, "Stopped watching" );
-			}
-		}
-	}
-}
-
-#if 0
+				irc_reply( irc, 602, "%s %s %s %d :%s", nick, "*", "*", 0, "Stopped watching" );
+			}
+		}
+	}
+}
+
 static void irc_cmd_topic( irc_t *irc, char **cmd )
 {
@@ -540,54 +443,124 @@
 	}
 }
-#endif
 
 static void irc_cmd_away( irc_t *irc, char **cmd )
 {
-	if( cmd[1] && *cmd[1] )
-	{
-		char away[strlen(cmd[1])+1];
+	user_t *u = user_find( irc, irc->nick );
+	char *away = cmd[1];
+	
+	if( !u ) return;
+	
+	if( away && *away )
+	{
 		int i, j;
 		
 		/* Copy away string, but skip control chars. Mainly because
 		   Jabber really doesn't like them. */
-		for( i = j = 0; cmd[1][i]; i ++ )
-			if( ( away[j] = cmd[1][i] ) >= ' ' )
+		u->away = g_malloc( strlen( away ) + 1 );
+		for( i = j = 0; away[i]; i ++ )
+			if( ( u->away[j] = away[i] ) >= ' ' )
 				j ++;
-		away[j] = '\0';
-		
-		irc_send_num( irc, 306, ":You're now away: %s", away );
-		set_setstr( &irc->b->set, "away", away );
-	}
-	else
-	{
-		irc_send_num( irc, 305, ":Welcome back" );
-		set_setstr( &irc->b->set, "away", NULL );
-	}
+		u->away[j] = 0;
+		
+		irc_reply( irc, 306, ":You're now away: %s", u->away );
+		/* irc_umode_set( irc, irc->myhost, "+a" ); */
+	}
+	else
+	{
+		if( u->away ) g_free( u->away );
+		u->away = NULL;
+		/* irc_umode_set( irc, irc->myhost, "-a" ); */
+		irc_reply( irc, 305, ":Welcome back" );
+	}
+	
+	set_setstr( &irc->set, "away", u->away );
+}
+
+static void irc_cmd_whois( irc_t *irc, char **cmd )
+{
+	char *nick = cmd[1];
+	user_t *u = user_find( irc, nick );
+	
+	if( u )
+	{
+		irc_reply( irc, 311, "%s %s %s * :%s", u->nick, u->user, u->host, u->realname );
+		
+		if( u->ic )
+			irc_reply( irc, 312, "%s %s.%s :%s network", u->nick, u->ic->acc->user,
+			           u->ic->acc->server && *u->ic->acc->server ? u->ic->acc->server : "",
+			           u->ic->acc->prpl->name );
+		else
+			irc_reply( irc, 312, "%s %s :%s", u->nick, irc->myhost, IRCD_INFO );
+		
+		if( !u->online )
+			irc_reply( irc, 301, "%s :%s", u->nick, "User is offline" );
+		else if( u->away )
+			irc_reply( irc, 301, "%s :%s", u->nick, u->away );
+		if( u->status_msg )
+			irc_reply( irc, 320, "%s :%s", u->nick, u->status_msg );
+		
+		irc_reply( irc, 318, "%s :End of /WHOIS list", nick );
+	}
+	else
+	{
+		irc_reply( irc, 401, "%s :Nick does not exist", nick );
+	}
+}
+
+static void irc_cmd_whowas( irc_t *irc, char **cmd )
+{
+	/* For some reason irssi tries a whowas when whois fails. We can
+	   ignore this, but then the user never gets a "user not found"
+	   message from irssi which is a bit annoying. So just respond
+	   with not-found and irssi users will get better error messages */
+	
+	irc_reply( irc, 406, "%s :Nick does not exist", cmd[1] );
+	irc_reply( irc, 369, "%s :End of WHOWAS", cmd[1] );
+}
+
+static void irc_cmd_nickserv( irc_t *irc, char **cmd )
+{
+	/* [SH] This aliases the NickServ command to PRIVMSG root */
+	/* [TV] This aliases the NS command to PRIVMSG root as well */
+	root_command( irc, cmd + 1 );
+}
+
+static void irc_cmd_motd( irc_t *irc, char **cmd )
+{
+	irc_motd( irc );
+}
+
+static void irc_cmd_pong( irc_t *irc, char **cmd )
+{
+	/* We could check the value we get back from the user, but in
+	   fact we don't care, we're just happy he's still alive. */
+	irc->last_pong = gettime();
+	irc->pinging = 0;
 }
 
 static void irc_cmd_version( irc_t *irc, char **cmd )
 {
-	irc_send_num( irc, 351, "bitlbee-%s. %s :%s/%s ",
-	              BITLBEE_VERSION, irc->root->host, ARCH, CPU );
+	irc_reply( irc, 351, "bitlbee-%s. %s :%s/%s ", BITLBEE_VERSION, irc->myhost, ARCH, CPU );
 }
 
 static void irc_cmd_completions( irc_t *irc, char **cmd )
 {
+	user_t *u = user_find( irc, irc->mynick );
 	help_t *h;
 	set_t *s;
 	int i;
 	
-	irc_send_msg_raw( irc->root, "NOTICE", irc->user->nick, "COMPLETIONS OK" );
+	irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", "OK" );
 	
 	for( i = 0; commands[i].command; i ++ )
-		irc_send_msg_f( irc->root, "NOTICE", irc->user->nick, "COMPLETIONS %s", commands[i].command );
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", commands[i].command );
 	
 	for( h = global.help; h; h = h->next )
-		irc_send_msg_f( irc->root, "NOTICE", irc->user->nick, "COMPLETIONS help %s", h->title );
-	
-	for( s = irc->b->set; s; s = s->next )
-		irc_send_msg_f( irc->root, "NOTICE", irc->user->nick, "COMPLETIONS set %s", s->key );
-	
-	irc_send_msg_raw( irc->root, "NOTICE", irc->user->nick, "COMPLETIONS END" );
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS help ", h->title );
+	
+	for( s = irc->set; s; s = s->next )
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS set ", s->key );
+	
+	irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", "END" );
 }
 
@@ -599,5 +572,5 @@
 		ipc_to_master( cmd );
 	
-	irc_send_num( irc, 382, "%s :Rehashing", global.conf_file );
+	irc_reply( irc, 382, "%s :Rehashing", global.conf_file );
 }
 
@@ -608,28 +581,26 @@
 	{ "quit",        0, irc_cmd_quit,        0 },
 	{ "ping",        0, irc_cmd_ping,        0 },
-	{ "pong",        0, irc_cmd_pong,        IRC_CMD_LOGGED_IN },
+	{ "oper",        2, irc_cmd_oper,        IRC_CMD_LOGGED_IN },
+	{ "mode",        1, irc_cmd_mode,        IRC_CMD_LOGGED_IN },
+	{ "names",       0, irc_cmd_names,       IRC_CMD_LOGGED_IN },
+	{ "part",        1, irc_cmd_part,        IRC_CMD_LOGGED_IN },
 	{ "join",        1, irc_cmd_join,        IRC_CMD_LOGGED_IN },
-	{ "names",       1, irc_cmd_names,       IRC_CMD_LOGGED_IN },
-	{ "part",        1, irc_cmd_part,        IRC_CMD_LOGGED_IN },
-	{ "whois",       1, irc_cmd_whois,       IRC_CMD_LOGGED_IN },
-	{ "whowas",      1, irc_cmd_whowas,      IRC_CMD_LOGGED_IN },
-	{ "motd",        0, irc_cmd_motd,        IRC_CMD_LOGGED_IN },
-	{ "mode",        1, irc_cmd_mode,        IRC_CMD_LOGGED_IN },
+	{ "invite",      2, irc_cmd_invite,      IRC_CMD_LOGGED_IN },
+	{ "privmsg",     1, irc_cmd_privmsg,     IRC_CMD_LOGGED_IN },
+	{ "notice",      1, irc_cmd_privmsg,     IRC_CMD_LOGGED_IN },
 	{ "who",         0, irc_cmd_who,         IRC_CMD_LOGGED_IN },
-	{ "privmsg",     1, irc_cmd_privmsg,     IRC_CMD_LOGGED_IN },
-	{ "nickserv",    1, irc_cmd_nickserv,    IRC_CMD_LOGGED_IN },
-	{ "ns",          1, irc_cmd_nickserv,    IRC_CMD_LOGGED_IN },
-	{ "away",        0, irc_cmd_away,        IRC_CMD_LOGGED_IN },
-	{ "version",     0, irc_cmd_version,     IRC_CMD_LOGGED_IN },
-	{ "completions", 0, irc_cmd_completions, IRC_CMD_LOGGED_IN },
 	{ "userhost",    1, irc_cmd_userhost,    IRC_CMD_LOGGED_IN },
 	{ "ison",        1, irc_cmd_ison,        IRC_CMD_LOGGED_IN },
 	{ "watch",       1, irc_cmd_watch,       IRC_CMD_LOGGED_IN },
-	{ "invite",      2, irc_cmd_invite,      IRC_CMD_LOGGED_IN },
-#if 0
-	{ "notice",      1, irc_cmd_privmsg,     IRC_CMD_LOGGED_IN },
 	{ "topic",       1, irc_cmd_topic,       IRC_CMD_LOGGED_IN },
-#endif
-	{ "oper",        2, irc_cmd_oper,        IRC_CMD_LOGGED_IN },
+	{ "away",        0, irc_cmd_away,        IRC_CMD_LOGGED_IN },
+	{ "whois",       1, irc_cmd_whois,       IRC_CMD_LOGGED_IN },
+	{ "whowas",      1, irc_cmd_whowas,      IRC_CMD_LOGGED_IN },
+	{ "nickserv",    1, irc_cmd_nickserv,    IRC_CMD_LOGGED_IN },
+	{ "ns",          1, irc_cmd_nickserv,    IRC_CMD_LOGGED_IN },
+	{ "motd",        0, irc_cmd_motd,        IRC_CMD_LOGGED_IN },
+	{ "pong",        0, irc_cmd_pong,        IRC_CMD_LOGGED_IN },
+	{ "version",     0, irc_cmd_version,     IRC_CMD_LOGGED_IN },
+	{ "completions", 0, irc_cmd_completions, IRC_CMD_LOGGED_IN },
 	{ "die",         0, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
 	{ "deaf",        0, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
@@ -657,17 +628,17 @@
 			if( irc_commands[i].flags & IRC_CMD_PRE_LOGIN && irc->status & USTATUS_LOGGED_IN )
 			{
-				irc_send_num( irc, 462, ":Only allowed before logging in" );
+				irc_reply( irc, 462, ":Only allowed before logging in" );
 			}
 			else if( irc_commands[i].flags & IRC_CMD_LOGGED_IN && !( irc->status & USTATUS_LOGGED_IN ) )
 			{
-				irc_send_num( irc, 451, ":Register first" );
+				irc_reply( irc, 451, ":Register first" );
 			}
 			else if( irc_commands[i].flags & IRC_CMD_OPER_ONLY && !strchr( irc->umode, 'o' ) )
 			{
-				irc_send_num( irc, 481, ":Permission denied - You're not an IRC operator" );
+				irc_reply( irc, 481, ":Permission denied - You're not an IRC operator" );
 			}
 			else if( n_arg < irc_commands[i].required_parameters )
 			{
-				irc_send_num( irc, 461, "%s :Need more parameters", cmd[0] );
+				irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
 			}
 			else if( irc_commands[i].flags & IRC_CMD_TO_MASTER )
@@ -686,4 +657,4 @@
 	
 	if( irc->status >= USTATUS_LOGGED_IN )
-		irc_send_num( irc, 421, "%s :Unknown command", cmd[0] );
-}
+		irc_reply( irc, 421, "%s :Unknown command", cmd[0] );
+}
